Shared posts

27 Dec 13:31

大连地铁时报12.26

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报12.26
发信站: 水木社区 (Tue Dec 26 20:41:53 2017), 站内

有的人 愣是把人生活成了一个梗

女:“我们分手吧,我实在忍受不了你这种一点男子汉气概都没有的人。”男子强忍着泪水,安慰自己:“不能哭,一定不能哭,如果哭出来,今天化的妆就会花的。”

医生:“从你的X光片来看,你的两根肋骨已经断了。”“天呐,医生,那我该怎么办?”医生:“没事,我已经用美图秀秀帮你修好了。”

我的脚有点臭,每次回到家,老婆第一件事就是让我去洗脚。昨晚太累了,我没洗脚就直接坐在沙发上看电视,一岁多的儿子在沙发旁边玩,闻到我的脚臭味转身走到卧室去了……那是儿子第一次学会走路。

小牛犊看到主人后,兴奋得活蹦乱跳,用小犄角顶主人玩儿。主人摸着它脑袋说:“哈哈,你是真皮啊。”第二天,主人用小牛犊做了个真皮钱包。

记得小学三年级,数学课上学了“四舍五入”,我兴奋得不行,回家悄悄拿了老爸50块钱,理所当然地花了3块钱,又放了回去……后来,老爸的那顿揍让我开始怀疑数学老师教得不对。

昨晚下了一晚雪,第二天我去楼下开车,发现车窗玻璃没了,车里面都是雪。我特别气愤,去找物业,告诉他们有人砸了我的车玻璃。物业工作人员看了一眼车:“姑娘,你下次能把车窗摇上不?”

一天,食堂大妈生病了,需要打针。护士拿着针管比划了半天,手还一直抖个不停。大妈看得胆战心惊:“姑娘,你抖啥?”姑娘面无表情地说:“当年在学校食堂,我也这样问过你,不记得了吗?”

宾馆的餐厅里,顾客问服务员:“你能告诉我,你们餐厅的桌布多长时间换一次吗?”“对不起,我到这里工作才3个月,我也不知道。”服务员抱歉地说。


笑出马甲线

量变导致质变,比如,马云本来是马云,但财富积累到一定程度,他突然就变成了有些人的爸爸。

要说不实用的小家电,我认为第一要数扫地机器人,那天,我家狗在地上拉了粑粑,扫地机器人竟然把它抹匀了。

在大城市打拼的小刘感到头顶压力很大,于是不到25岁就秃顶了;小李上有老下有小,感到肩上的担子很重,于是得了肩周炎。


段子手荟萃

为了身体健康,我每天都坚持6点起床。久而久之,我终于养成了睡回笼觉的好习惯。

爸爸:“孩子,考试考得怎么样?”女儿:“不怎么好。”爸爸:“考了多少分?”女儿:“数学零分,语文6分。”爸爸:“嗯,是不怎么好,有点偏科啊。”

考试前一星期,我是家里的一级保护动物;考完试,我变成了野生动物;分数出来后,我又成了人人喊打的害虫。

25 Dec 09:25

大连地铁时报12.20

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报12.20
发信站: 水木社区 (Wed Dec 20 21:11:56 2017), 站内

讲道理,真没必要跟吃货较真儿

昨天去食堂排队买饭,一个小伙子没端好热汤,泼了我一腿,然后他马上返回餐台,我以为他去给我要点纸,结果他说:“师傅,加点汤……”

媳妇儿晚上睡觉时,突然咳嗽醒了,我赶紧问:“你怎么了?”
结果媳妇儿说:“我梦见一桌子好吃的,咽了咽口水准备吃,结果呛到自己了,咳着咳着就醒了”

在微信上看到一向很宅的老婆今天居然走了800步,我问她是怎么做到的,她说:“饭后百步走。”唉,希望她以后每天只走300步。

晚上吃晚饭,在食堂看见食堂的大师傅在吃泡面,觉得好心酸。可后来想想,我好像明白了什么……

睡觉前,女儿要吃苹果,我哄她说:“苹果里面有虫子,明天妈妈把虫子洗掉了你再吃。”女儿:“妈妈,你快让我吃了吧,明天苹果就被虫子吃光了。”

有个土豪哥们叫大伙到他家聚餐,问我们吃什么好?我说大冷天的,吃羊肉吧,他说不会做,我叫他把食材准备好,我来做。到他家一看,一只活羊拴在院子里,别说宰了,我打都打不过它。

第一次去男朋友家,男朋友的七大姑八大姨纷纷来凑热闹。临走时,他们把送给我们的鸡鸭鱼蛋等东西纷纷往男友车子的后备箱里塞……眼看就要塞完了,男朋友一下关了后备箱,把我拉上车说:“快……快撤!我二叔赶着一头猪来了。”

坐火车,对面妹子不停地吃零食,看得我有点饿了,下意识地咽了咽口水,妹子愣了一下,然后非常紧张地捂紧了零食!



笑出马甲线

昨天过生日,收到一个快递,装着一个红色信封,还是空的。正在纳闷,老妈来电话了:“给你快递了一个红包,让你高兴高兴,钱转你卡上了,快递不安全,就寄个皮。”

周末我跟我哥去公园玩海盗船,下来后我一直哆嗦,我哥却跟没事人一样。
我妈就说我:“吓成这熊样,以后别玩了!浪费钱!”
看到我哥一直在笑,老妈又说他:“你一点都不怕,下次别玩了!浪费钱!”
果然是亲妈,解释都好合理啊!

最讨厌看见露腿就问冷不冷的人了,我又不是机器人当然冷了!这么冷我都露腿了还不是为了臭美吗?



段子手荟萃

朋友:这次画展又没卖出去画啊?
画家:没,但是很受鼓舞。
朋友:为啥?
画家:有幅画被偷了。 笑话大全

19 Dec 14:11

持续集成服务 Travis CI 教程

编写代码只是软件开发的一小部分,更多的时间往往花在构建(build)和测试(test)。

为了提高软件开发的效率,构建和测试的自动化工具层出不穷。Travis CI 就是这类工具之中,市场份额最大的一个。

本文介绍 Travis CI 的基本用法。用好这个工具不仅可以提高效率,还能使开发流程更可靠和专业化,从而提高软件的价值。而且,它对于开源项目是免费的,不花一分钱,就能帮你做掉很多事情。

一、什么是持续集成?

Travis CI 提供的是持续集成服务(Continuous Integration,简称 CI)。它绑定 Github 上面的项目,只要有新的代码,就会自动抓取。然后,提供一个运行环境,执行测试,完成构建,还能部署到服务器。

持续集成指的是只要代码有变更,就自动运行构建和测试,反馈运行结果。确保符合预期以后,再将新代码"集成"到主干。

持续集成的好处在于,每次代码的小幅变更,就能看到运行结果,从而不断累积小的变更,而不是在开发周期结束时,一下子合并一大块代码。

二、使用准备

Travis CI 只支持 Github,不支持其他代码托管服务。这意味着,你必须满足以下条件,才能使用 Travis CI。

  • 拥有 GitHub 帐号
  • 该帐号下面有一个项目
  • 该项目里面有可运行的代码
  • 该项目还包含构建或测试脚本

如果这些条件都没问题,就可以开始使用 Travis CI 了。

首先,访问官方网站 travis-ci.org,点击右上角的个人头像,使用 Github 账户登入 Travis CI。

Travis 会列出 Github 上面你的所有仓库,以及你所属于的组织。此时,选择你需要 Travis 帮你构建的仓库,打开仓库旁边的开关。一旦激活了一个仓库,Travis 会监听这个仓库的所有变化。

三、.travis.yml

Travis 要求项目的根目录下面,必须有一个.travis.yml文件。这是配置文件,指定了 Travis 的行为。该文件必须保存在 Github 仓库里面,一旦代码仓库有新的 Commit,Travis 就会去找这个文件,执行里面的命令。

这个文件采用 YAML 格式。下面是一个最简单的 Python 项目的.travis.yml文件。


language: python
script: true

上面代码中,设置了两个字段。language字段指定了默认运行环境,这里设定使用 Python 环境。script字段指定要运行的脚本,script: true表示不执行任何脚本,状态直接设为成功。

Travis 默认提供的运行环境,请参考官方文档 。目前一共支持31种语言,以后还会不断增加。

下面是一个稍微复杂一点的.travis.yml


language: python
sudo: required
before_install: sudo pip install foo
script: py.test

上面代码中,设置了四个字段:运行环境是 Python,需要sudo权限,在安装依赖之前需要安装foo模块,然后执行脚本py.test

四、运行流程

Travis 的运行流程很简单,任何项目都会经过两个阶段。

  • install 阶段:安装依赖
  • script 阶段:运行脚本

4.1 install 字段

install字段用来指定安装脚本。


install: ./install-dependencies.sh

如果有多个脚本,可以写成下面的形式。


install:
  - command1
  - command2

上面代码中,如果command1失败了,整个构建就会停下来,不再往下进行。

如果不需要安装,即跳过安装阶段,就直接设为true


install: true

4.2、script 字段

script字段用来指定构建或测试脚本。


script: bundle exec thor build

如果有多个脚本,可以写成下面的形式。


script:
  - command1
  - command2

注意,scriptinstall不一样,如果command1失败,command2会继续执行。但是,整个构建阶段的状态是失败。

如果command2只有在command1成功后才能执行,就要写成下面这样。


script: command1 && command2

4.3 实例:Node 项目

Node 项目的环境需要写成下面这样。


language: node_js
node_js:
  - "8"

上面代码中,node_js字段用来指定 Node 版本。

Node 项目的installscript阶段都有默认脚本,可以省略。

  • install默认值:npm install
  • script默认值:npm test

更多设置请看官方文档

4.4 部署

script阶段结束以后,还可以设置通知步骤(notification)和部署步骤(deployment),它们不是必须的。

部署的脚本可以在script阶段执行,也可以使用 Travis 为几十种常见服务提供的快捷部署功能。比如,要部署到 Github Pages,可以写成下面这样。


deploy:
  provider: pages
  skip_cleanup: true
  github_token: $GITHUB_TOKEN # Set in travis-ci.org dashboard
  on:
    branch: master

其他部署方式,请看官方文档

4.5 钩子方法

Travis 为上面这些阶段提供了7个钩子。

  • before_install:install 阶段之前执行
  • before_script:script 阶段之前执行
  • after_failure:script 阶段失败时执行
  • after_success:script 阶段成功时执行
  • before_deploy:deploy 步骤之前执行
  • after_deploy:deploy 步骤之后执行
  • after_script:script 阶段之后执行

完整的生命周期,从开始到结束是下面的流程。

  1. before_install
  2. install
  3. before_script
  4. script
  5. aftersuccess or afterfailure
  6. [OPTIONAL] before_deploy
  7. [OPTIONAL] deploy
  8. [OPTIONAL] after_deploy
  9. after_script

下面是一个before_install钩子的例子。


before_install:
  - sudo apt-get -qq update
  - sudo apt-get install -y libxml2-dev

上面代码表示before_install阶段要做两件事,第一件事是要更新依赖,第二件事是安装libxml2-dev。用到的几个参数的含义如下:-qq表示减少中间步骤的输出,-y表示如果需要用户输入,总是输入yes

4.6 运行状态

最后,Travis 每次运行,可能会返回四种状态。

  • passed:运行成功,所有步骤的退出码都是0
  • canceled:用户取消执行
  • errored:before_installinstallbefore_script有非零退出码,运行会立即停止
  • failed :script有非零状态码 ,会继续运行

五、使用技巧

5.1 环境变量

.travis.ymlenv字段可以定义环境变量。


env:
  - DB=postgres
  - SH=bash
  - PACKAGE_VERSION="1.0.*"

然后,脚本内部就使用这些变量了。

有些环境变量(比如用户名和密码)不能公开,这时可以通过 Travis 网站,写在每个仓库的设置页里面,Travis 会自动把它们加入环境变量。这样一来,脚本内部依然可以使用这些环境变量,但是只有管理员才能看到变量的值。具体操作请看官方文档

5.2 加密信息

如果不放心保密信息明文存在 Travis 的网站,可以使用 Travis 提供的加密功能。

首先,安装 Ruby 的包travis


$ gem install travis

然后,就可以用travis encrypt命令加密信息。

在项目的根目录下,执行下面的命令。


$ travis encrypt SOMEVAR=secretvalue

上面命令中,SOMEVAR是要加密的变量名,secretvalue是要加密的变量值。执行以后,屏幕上会输出如下信息。


secure: ".... encrypted data ...."

现在,就可以把这一行加入.travis.yml


env:
  global:
    - secure: ".... encrypted data ...."

然后,脚本里面就可以使用环境变量$SOMEVAR了,Travis 会在运行时自动对它解密。

travis encrypt命令的--add参数会把输出自动写入.travis.yml,省掉了修改env字段的步骤。


$ travis encrypt SOMEVAR=secretvalue --add

详细信息请看官方文档

5.3 加密文件

如果要加密的是文件(比如私钥),Travis 提供了加密文件功能。

安装命令行客户端以后,使用下面的命令登入 Travis CI。


$ travis login 

然后,进入项目的根目录,使用travis encrypt-file命令加密那些想要加密的文件。


$ travis encrypt-file bacon.txt

encrypting bacon.txt for rkh/travis-encrypt-file-example
storing result as bacon.txt.enc
storing secure env variables for decryption

Please add the following to your build script (before_install stage in your .travis.yml, for instance):

    openssl aes-256-cbc -K $encrypted_0a6446eb3ae3_key -iv $encrypted_0a6446eb3ae3_key -in bacon.txt.enc -out bacon.txt -d

Pro Tip: You can add it automatically by running with --add.

Make sure to add bacon.txt.enc to the git repository.
Make sure not to add bacon.txt to the git repository.
Commit all changes to your .travis.yml.

上面的代码对文件bacon.txt进行加密,加密后会生成bacon.txt.enc,该文件需要提交到代码库。此外,该命令还会生成一个环境变量$encrypted_0a6446eb3ae3_key,保存密钥,储存在 Travis CI,文件解密时需要这个环境变量。你需要把解密所需的openssl命令,写在.travis.ymlbefore_install字段里面。这些都写在上面的命令行提示里面。

--add参数可以自动把环境变量写入.travis.yml


$ travis encrypt-file bacon.txt --add

encrypting bacon.txt for rkh/travis-encrypt-file-example
storing result as bacon.txt.enc
storing secure env variables for decryption

Make sure to add bacon.txt.enc to the git repository.
Make sure not to add bacon.txt to the git repository.
Commit all changes to your .travis.yml.

详细信息请看官方文档,实际的例子可以参考下面两篇文章。

(完)

文档信息

16 Dec 07:37

大连地铁时报12.14

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报12.14
发信站: 水木社区 (Fri Dec 15 07:28:25 2017), 站内

你只猜对了故事的开头

我一朋友,有一次坐黑车,车被交警拦下了。情急之下,司机连忙解释:“我们是朋友,我有他电话。”说着,便打他手机。因为我朋友坐他车好几次了,所以互相留了电话号码。这时,朋友的手机响了,交警拿过来一瞧,上面写着:“黑车司机”……

昨天下午,家里安排我跟一个妹子相亲,我俩都接到了家里的死命令:必须跟对方吃完晚饭才能回家!时间还早,我和妹子在茶馆尴尬无语中……然后,妹子掏出手机,一边抽烟一边玩游戏。而我,看她玩得正欢,只好从包里默默地拿出了即将完工的十字绣……

我姐比我大两岁,我妈说,我还不会走路的时候,有一次,我妈做饭,让我姐看着我,不要让我随便吃脏东西。然后,我妈无意间隔着窗户发现,我在地上爬着,抓起一片干鸡屎就往嘴里塞。我姐看见了,大喊一声,然后冲过来吹了吹鸡屎片上面的灰,又递给了我……

记得上学时语文考试有一道题目,李清照是什么派,我写的是武当派。发试卷时,老师说有一位同学的答案可以去请家长了,当时我吓得瑟瑟发抖,瞄了一眼同桌写的答案——蛋黄派,瞬间轻松了许多。

小明带了一个小朋友回家玩,小朋友走后妈妈问:“小明,刚才那个同学,在班里第几名呀?”小明:“倒数第一名。”妈妈生气,啪啪地逮住小明一顿暴打:“让你不学好,让你不学好,我不是说过不要跟比你差的孩子玩吗?你要跟第一名玩!”小明委屈地说:“我刚开始跟他玩的时候,他确实是第一名呀!”

翻了一下老婆以前的动态,刚认识那会儿,她在朋友圈晒过我俩的合照。这个我记得,不过那时我和她家里人不是好友,看不到他们的评论。现在我们结婚了,终于可以看到了。当时丈母娘在我们俩的合照下方评论:中下。小姨子:同意楼上。老丈人:这小子看起来心术不正!

昨天晚上请女友吃饭,正打算求婚,刚好碰见一个卖花的小姑娘。于是,我花10块钱向小姑娘买了一朵玫瑰花,并叮嘱她一会儿我会把求婚戒指套在玫瑰花上,让她先藏起来。等女友来了,她再假装过来卖花,我买一朵再顺势向女友求婚。谁料,等一切就绪时,小姑娘竟然跑来悄悄地对我说:“加100,不然我马上叫你‘爸爸’!”

14 Dec 07:07

大连地铁时报12.13

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报12.13
发信站: 水木社区 (Wed Dec 13 22:05:22 2017), 站内

梦想,咋就这么容易实现

大早上闺女跟我说:“前一天晚上做了个梦,梦到跟奶奶去超市了,奶奶什么吃的也没给我买。”这不一大早搂着奶奶不依不饶的,非让奶奶给补上。不补上就不去上学。这大概就是吃货的最境界了。

单位有一个同事,处的第一个女朋友分手后去了韩国,第二个女朋友分手后去了日本,第三个去了塞班岛。昨天同事大姐给他介绍对象,对他说:“这女孩想去新加坡来着,结果没去成,我寻思让她跟你处个对象,借借你的运气!”

小时候梦想什么也不用干,人家抢着给我塞钱。如今梦想终于实现了,我成了一名饭店服务员,昨天一桌4个人吃完饭抢着结账,拽着我,往我手里、兜里塞钱,梦想实现的感觉,很难形容。

女儿3岁时,我责备她不该重复别人的谎言,告诫她千万别说谎。她问:“为什么?”我说:“说谎的小孩会变成花,种在花盆里当装饰。”为了确定她明白我的苦心,我问:“你知道我的意思吗?”她冷静地回答:“知道,这是个谎言。”

上个月收拾屋子的时候,我在男朋友的鞋里面发现了私房钱,正打算生气的时候,又翻到一张纸条,上面写着“给老婆买口红的”,顿时心里暖暖的,我就原封不动地把这钱放回去了,可是我等了1个月也没等到自己的口红。

过去我给人一种很瘦弱的感觉,听说健身能改变人的气质,于是忍痛用这个月的工资办了一张健身卡,现在的我气质果然不一样了,给人一种到处蹭饭、很讨厌的感觉。

业务员:“需要理财顾问吗?”
我:“已经有了!”
业务员:“哪家公司的?”
我:“我老婆!”
业务员:“先生,您可以考虑其他投资,请问您想投资贵金属吗?”
我:“已经投了很多了!”
业务员:“您都投资了什么贵金属?”
我:“老婆的金戒指、金耳环、金项链!”

坐公交遇到一对母子,男孩就六七岁。小孩要开窗户,他自己打不开就让他妈帮他打开,他妈说自己没劲,打不开窗户。孩子说:“你打我就有劲儿,让你开个窗户就没劲儿。”



笑出马甲线

@想要锁骨的妹纸
我一个室友向我抱怨说:“越来越讨厌现在的游戏了,动不动就要充值、邀请好友,本来我就是因为没钱、没朋友才玩游戏的。”

@快递员
当快递员不能跟客户混太熟,他们每次在附近打不着车时,就打电话给我,骗我说有快件要发,还是很急很急的那种,告诉我他们在哪个路口等我,最后我只能无可奈何地捎他回家。

@我是你大哥
13 Dec 10:02

大连地铁时报12.11

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报12.11
发信站: 水木社区 (Tue Dec 12 08:01:21 2017), 站内

有些“优点”还是不暴露的好

1.小表弟的头不小心撞到了墙上,一直在哭,便问目击者乐乐,他是怎么撞到的。乐乐二话不说,直接用自己的头往墙上撞去,哇地一声哭了,边哭还边说:“就是这样撞到的。”家里顿时可热闹了,“男子二重哭”不绝于耳……

2.古时有一小国,因战事频频导致国库不支。
皇帝慌忙叫来朝中一个大臣,命其将自己家产充公,以做军费。
大臣不愿却也不敢抗命,只怯怯地问了一句:“朝中大臣那么多,为何是我?”
皇帝走到他的面前,拍拍他的肩膀说:“因为爱卿,不会轻易悲伤……”

3.男生声音好听真得非常重要。我有个朋友在外面犯了事,本来是要拘留24小时的,后来有个女警官听到他回答询问的声音后,主动帮他延长到48个小时。

4.合租室友毛病很多,我实在忍受不下去,于是找他谈话。
我:“有话跟你说,憋不住了。”
室友:“啥?”
我:“我不住了!”
室友:“不住就不住呗,可你为啥说自己是鳖?”

5.第一次跟男朋友去他家,刚看到他妈妈,我赶紧打招呼:“阿姨好。”他妈妈拉着我的手亲切地说:“叫什么阿姨呀,叫妈好了。”我害羞低叫了一声:“妈。”他妈妈高兴地说道:“哎,我就认你这个女儿了,以后有机会给你介绍个好点的对象。”

6.去饮品店买果汁,店员介绍说:“我们家的混合果汁不错,苹果+梨、橙+蓝莓都很好喝。”我喜欢吃李子,于是问她:“那李+橙会是什么味道?”她想了想说:“很有钱的味道吧。”

7.约会时如何判断一个女人真的吃饱了?
直接问她:“你吃饱了吗?”这是直男常见的错误。
无论饱没饱,你得到的答案都会是吃饱了,或者差不多、不需要……
正确的应该是,你暗中观察她补口红没有?如果补了口红那就说明真的饱了,不想再吃了。
女人可以随意欺骗男人,但是她们绝对不会浪费自己的化妆品。

8.苦者登高问禅师:“大师,有钱到底有多快乐?”禅师笑而不语,拿出一叠又一叠的钱,直到桌上已经堆钱如山了,苦者不禁问:“您是要把这些钱都给我,让我体验一下吗?”禅师摇摇头:“不不不,我只是要让你看看我有多快乐。哈哈哈,看到了吗?”


笑出马甲线

@啊勒路呀
今天和老妈去吃酒席,去之前老妈教我,出去嘴要甜一点,说看见别人小孩长得还过得去的,就要夸奖人家长得好漂亮,实在看着丑的就夸奖别人长得好高。不知道为什么,吃个饭的功夫,已经有好多人夸我长得高了。

@百思不得姐
13 Dec 09:59

你小时候做过哪些匪夷所思的事情。

by Rio2016
发信人: Rio2016 (2016 Summer Olympics), 信区: Joke
标 题: 你小时候做过哪些匪夷所思的事情。
发信站: 水木社区 (Fri Dec 8 17:33:49 2017), 站内

我先说一个,小时候看电视剧,每集结束后会有演职员字幕。那时候我都是瞪大眼睛尽量把每一个人名都看到。 我这么做的原因是,我当时觉得那么多工作人员费心卖力的拍电视剧最终的回报就是片尾显示下自己的名字。 如果没人看他们肯定很伤心。

直到有一年电视台播一部叫做莲花争霸的港台片,片尾字幕那叫一个快,基本上是一闪而过,我当时就怀疑人生了
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 61.148.243.*]

06 Dec 14:23

我和快递小哥之间的搞笑经历

by jiale123
发信人: jiale123 (jiale123), 信区: Joke
标 题: 我和快递小哥之间的搞笑经历
发信站: 水木社区 (Tue Dec 5 17:18:22 2017), 站内

有一次买了一个除毛器,大概路上颠簸的时候开关被震开了,快递小哥送货的时候狂打我电话,那时我正在上班,没接到,他直接冲到我单位一边跑一边喊:“某某你的快递!!!一直在震动!!!是不是炸弹啊!!!你拆开看看啊!!!”
--
我同事便说:好端端上着班突然来个炸弹?太尼玛惊心动魄了!还让不让人安心工作了?
※ 修改:·jiale123 于 Dec 5 17:19:27 2017 修改本文·[FROM: 113.116.51.*]
※ 来源:·水木社区 http://www.newsmth.net·[FROM: 113.116.51.*]
05 Dec 07:07

50条知乎点赞最高的段子,已笑喷

by infinetely
发信人: infinetely (∞∞∞∞∞∞∞∞), 信区: Joke
标 题: 50条知乎点赞最高的段子,已笑喷
发信站: 水木社区 (Tue Dec 5 11:47:48 2017), 站内

不是段子
这就是生活

1
说一句很有内涵的诗句
一懒众衫小

2
你听过的第一个3D环绕音乐是什么?
丢手绢

3
一整个披萨你要切8块还是12块?
8块吧,12块我吃不下

4
如果你是别人,你愿意和自己处对象么?
想都不敢想,哪有这种福气

5
要是在古代,姐的颜值能撑起整个青楼!
你是说你长得像柱子吗?

6
用一句话形容你的罩杯
随爹[doge]

7
对不起,我们可能不太合适
放屁,我百搭

8
穷不是一种状态
穷是一种常态

9
你怎么一个人逛街啊?
半个人逛街我怕吓着你!

10
地球外面那一层是什么?
香飘飘奶茶

11
历史老师:你为什么交白卷?
我:我怕我会篡改历史

12
小学生当街闹分手
网友:请给90后空巢老人多些关爱

13
你们这些年轻人,就是把钱看得太重了!
放桌上也不拿东西压,风吹跑了怎么办。

14
服务员:“很高兴为您服务”
我:“你高兴的太早了”

15
男朋友吃女朋友豆腐正常吗?
没结婚就动手动脚的,那结婚后岂不是要上床?

16
问:在武侠世界里开一家客栈要注意什么?
答:墙上贴上字:要打出去打。



17
服务员:“请问我有什么可以帮您的吗”
“有啊,你能帮我付钱吗”

18
一次dota,队友:我有点卡,你们呢?
另一队友:这游戏还有点卡?!在哪买?

19
广播体操太假了,
女生做了十几年的扩胸运动一点效果都没。
那你看见过跳拉丁舞的男生丁丁被拉长吗。

20
北冥有鱼,其名为鲲,
鲲之大,跟你体型差不多。
化而为鸟,其名为鹏,
鹏之背,跟你运气差不多。

21
有一次看别人求婚,
我问我朋友为什么求婚是单膝跪地?
她说双膝跪地那是上坟。


22
谁能想到,这名16岁少女,
4年前只是一位12岁少年。

23
问:世上不会游泳的动物是?
答:媳妇和妈

24
我想摸你的头发只是简单的试探啊
嗯!真的很油!

25
sunshine组合新歌《我要做你女朋友》
网友:我拒绝

26
寒冷的环境可以使人变得更年轻
小明爷爷今年70岁,出门冻得跟孙子似的

27
女生:我生气了,你就算给我买cpb也没用
男生:那不买了不买了,别生气了

28
如果被车撞飞10米远,
爬起来之后说什么最帅?
下一辆。

29
孙悟空头上的圈叫什么
猴头菇

30
妈,我是你的什么
妈的智障

31
我问电风扇我丑么,
然后电风扇摇了一夜的头,
顿时感觉好多了
别听电风扇的,它都是吹的

32
05 Dec 07:01

Re: 你们捡到过什么好东西么?

by panxf
发信人: panxf (panxf), 信区: Joke
标 题: Re: 你们捡到过什么好东西么?
发信站: 水木社区 (Sun Dec 3 10:21:02 2017), 站内


【 在 DDOO 的大作中提到: 】

邻居家的大大哥有一对让人羡慕的鸡蛋大小的铁蛋珠,

一天他不小心把一只铁蛋珠掉草丛中了,找了小半天找不到。
他放弃了,然后他很失落的去河边洗了手。

正打算去游泳的我路过那草丛,一眼就看到了那铁蛋珠。
然后下了河想摸点田螺,一把又从一个石头缝里摸出一另一颗铁蛋珠。

于是前后不到两分钟,那对让人羡慕的铁蛋珠尽入我手!!!!

--

※ 来源:·水木社区 http://www.newsmth.net·[FROM: 114.240.70.*]
30 Nov 10:25

病例一则

by TGIF
发信人: TGIF (周末), 信区: Joke
标 题: 病例一则
发信站: 水木社区 (Wed Nov 29 11:48:13 2017), 站内

【病例一则】
某女,因丈夫家暴而长期失眠。
医生按《黄帝内经》的理论给开了生铁落饮,可是药房抓不到这味药,医生嘱其改用磨刀水煮大枣喝。
于是该女每天在家磨菜刀。
从此,再未听说家暴的事,她的失眠症也很快治愈了!
--

※ 来源:·水木社区 http://www.newsmth.net·[FROM: 114.243.251.*]
29 Nov 05:12

大连地铁时报11.16

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.16
发信站: 水木社区 (Fri Nov 17 06:33:18 2017), 站内

和熊孩子斗智斗勇那点事儿

晚上散步,听见一个老太太对小孙女说:“我的同学们约定一年聚一次,一直坚持了十几年,可来的人越来越少。今年只剩下我和另外三个同学了……”闻此言我心头一紧,心想人生不过尔尔,终要归去。然后老太太停顿片刻,厉声发问:“我都启发到这了,还想不起来吗?”小女孩:“想起来了,遥知兄弟登高处,遍插茱萸少一人。”

昨晚跑顺风车,接了一单送小情侣回学校,当时差不多10点40了,听他们的意思过了11点寝室就关大门。我听到男生说:“估计来不及了,要不今天外边住吧。”女生害羞地“嗯”了一声。我顿时倦意全无,猛地抬头说:“你们放心,哥的车350马力,绝对来得及!”然后一顿炫酷的操作,准时把他们送回了学校!

老师打电话到家里告状,说我上课时和同桌一起睡觉,都打呼噜了,性质极其恶劣,严重影响了其他同学的正常学习。挂掉电话后,老妈边打我,边骂道:“叫你晚上熬夜玩手机!叫你晚上熬夜玩手机!”老爸边打我,边骂道:“你同桌男的女的!你同桌男的女的!”

大儿子今年15岁了,老婆又给我生个儿子。在这个生男不如生女的年代,唯一的好处就是,买东西讨价还价的时候,如果我低着头和老板说:“我有俩个儿子。”多少人家都会给我便宜点儿。

儿子上一年级了,为了培养儿子多读书,我给他买了《水浒传》的彩图画册,他很喜欢看。昨天儿子问我:“爸爸,五花大是谁?”我左思右想也没想起水浒中有个五花大,就让儿子把书拿来我看一下,只见书上赫然写着:李逵一觉醒来,已经被五花大绑了起来!

去吃米线的时候,领桌一对母女正在讨论以后做什么工作。妈妈说:“你长大了我就给你整容。”女儿问:“整容干吗?”妈妈说:“整容了好当明星!”女儿说:“明星不一定整容啊,我才不整容。”妈妈又说了:“你不整容你就当笑星吧。”

30年前,人们惊呼流行音乐会毁掉下一代;20年前,人们惊呼电视节目会毁掉下一代;10年前,人们惊呼电脑和因特网会毁掉下一代;现在,人们开始惊呼手机会毁掉下一代……可人类发展的历史证明: 没有任何力量能毁掉下一代,除了上一代。

29 Nov 05:10

大连地铁时报11.27

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.27
发信站: 水木社区 (Mon Nov 27 21:23:30 2017), 站内

是特别的缘分,让我有这样的家人?

我最佩服那些一见到美女就暂时性失忆的人,好像突然就忘了自己有老婆孩子一样,能坦然地跟美女打情骂俏。我就不行了,一调戏美女就会想到自己的老婆孩子,良心就痛,所以想问问大家,离婚手续办起来麻烦吗?

我爷爷曾警告过人们泰坦尼克号的事,当时他大喊:“前面有冰山!船要沉了!”结果却根本没有人听,只是把他撵出了电影院。

我虽然不是富二代,但我相信,只要我够努力、够上进,我就可以把我的孩子教育成一个吃得起苦的人。

跟哥们闲聊,我问他:“要是有人绑架了你媳妇,你愿意出多少钱赎?”哥们说:“一分钱也出不了。”他抽口烟又说,“除非她告诉我银行卡密码。”

昨晚吃完饭,老公突然说:“全天下的女人在我眼里就两个样子,一个是你。”我有些羞涩,问:“另一个呢?”老公说:“瘦子。”

老婆在纸上写了一大堆数据,然后跟我说:“你看,每个月房贷、车贷、柴米油盐、水电费、孩子的花费……你的工资就这么没了。”我:“那你的工资呢?”她:“我的工资关你什么事!”

老公最近健忘得很。家里灯泡坏了,他骑着摩托车去买灯泡,买回来一看钱包忘在店里了,又回去拿钱包,结果又把手机忘在店里了,又回去拿手机。回家安灯泡后发现不亮,老公又得回去换灯泡,这次他学聪明了,带着我去,我俩刚到店里,老板就来了一句:“哟呵,老婆也不想要了?”

我姐夫是做微商的,到现在都买第5辆保时捷了,他说他就喜欢保时捷。后来他拉我入行,我仅仅用了1年的时间就积累了20多万,说真的,我活这么大都没欠过这么多钱。


神句ONE

各个社交和购物网站的“猜你喜欢”从没有猜中过我喜欢什么。

用一句话形容我的长相就是:眼皮无双至,下巴不单行。

别看有些人表面上一副无所畏惧的样子,实际上早就悄悄把棉裤穿上了。

当才华撑不起野心的时候,就要多读书,读着读着,野心也就没了。

(部分笑话取自网络,如有侵权请联系删除)
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 123.151.77.*]

29 Nov 05:07

大连地铁时报11.23

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.23
发信站: 水木社区 (Thu Nov 23 20:41:20 2017), 站内

生活微苦,但你得甜

当代单身男性大学生太可怕了。昨晚我在帘子里看剧,正好看到女主角去厨房洗水果,洗了三四秒吧,我帘子突然被掀开,舍友硕大的脑袋赫然出现在我面前,一双透露着无限渴望的眼睛直勾勾盯着我:“是不是有女的洗澡呢?我看看。”

在城里摸打滚爬了7年,终于买了套小房子。去取公积金的时候,工作人员是个妹子,她先给了我张表格,然后问我:“单身吗?”我愣了下,心想,难道我今天特别帅吗?我如实答道:“不好意思啊,我有女朋友了。”妹子白了我一眼说:“是单身还是已婚!”

昨天在电器商场,看到电视里讲一个男主角白手起家成为亿万富翁的故事,我便暗暗发誓,一定要努力赚钱,把这台两千块钱的电视买回家。

单身久了,一个同学来图书馆带吃的给我,我连以后怎么给我们收养的孩子解释为什么他会比别人多一个爸爸少一个妈妈都想好了。

程序员家的水管坏了,他打电话叫水管工来修理。水管工鼓捣了1个小时,终于把管子修好了,他递给程序员一张600元的帐单。“600元!”程序员愤怒地说,“我当程序员一天都赚不了这么多钱!”“是啊。”水管工平静地说,“我当程序员的时候也是。”

如果美女说:“哈哈,我去洗澡!”过了一年没回你,表示她根本不想回你。如果程序员说:“哈哈,我去上班!”过了一年没回你,表示他根本还没下班。

晚上健完身有点口渴,看到路边摊有卖橘子,于是挑了几颗好看的橘子。老板拿起几颗有斑点的就往袋子里塞,说:“帅哥,这种长得不好看的其实更甜。”我好奇地问:“是因为橘子觉得自己长得不好看,所以努力让自己变甜吗?”老板微微一愣,看智障似的看着我:“不是,我只想早点卖完回家。”

小时候有一次,我考了倒数第一,我拿着成绩单回到家里,觉得自己可能活不过那个晚上了。我想起电视里有句台词:“我死也要死得美美的!”于是我瘫在沙发上,随手拿起妈妈的口红,给自己抹了个红嘴唇,然后撅起嘴到处亲,最后亲在了爸爸的白衬衫上……晚上妈妈下班回家了,他俩打得不可开交,都没人管我考了几分。


笑出马甲线

@大面包小草莓
作为一名监考老师,我还是要奉劝一下各位考生,在考场的时候千万不要睡觉,因为看见你们睡觉我也想睡!

@半醉半醒半懵74
有一次我坐公交车,突然有人昏倒了,周围乘客都不知该如何是好。这时我注意到车上写着如遇紧急情况请凿碎玻璃的提示。我按着提示去做了,可那人还是不醒。

27 Nov 07:07

[转载]0,0,0,0 求 24 点

by pauljoe
发信人: pauljoe (袋鼠妈妈有个袋袋), 信区: Joke
标 题: [转载]0,0,0,0 求 24 点
发信站: 水木社区 (Mon Nov 27 08:58:54 2017), 站内 [累计积分奖励: 500/0]

我弟今年上了大班,有一天我爸突然半夜找我,问我会不会算 24 点。

我弟幼儿园布置了一道 24 点的作业,我爸根本不会做。

哇,一听我就来劲了。

然后我爸就给我发来了一道题。

0,0,0,0 求 24 点。

????

这种老题目都做烂了。

(0!+0!+0!+0!)!=24

我给我爸解释了遍什么叫「阶乘」。

问题是,我弟才大班,现在小朋友学的都这么超前的吗?

我爸问我还有没有别的方法,这个估计我弟听不懂。

我思考了会,安慰了我爸一波。

「现在跟以前不一样了,他们接触的世界是多元化的。学的东西也比以前难好多了。而且这题只有这一种解法啊。」

我爸回了个 微笑 的表情。

第二天,我问我爸,那题目怎么样了。

我爸说,不太对。

然后我问他答案。

00:00
--

※ 来源:·水木社区 http://www.newsmth.net·[FROM: 211.103.173.*]
27 Nov 07:06

大连地铁时报11.26

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.26
发信站: 水木社区 (Sun Nov 26 20:18:14 2017), 站内

有泪不轻弹,还不是因为不够惨?

表妹受过情伤,和前男友分得坚定决绝,拉黑了微信QQ,相互发誓生死不再相见。昨天她骑着电瓶车去了前男友小区,把他脸挠花了。我劝她想开点,她气愤地说:“太缺德了!就一个支付宝没删,王八蛋竟敢偷我能量!”

我和儿子有个共同的心愿,就是出国旅游。昨天儿子考试得了全班第一,我跟媳妇合计着带他出国见见世面。吃晚饭的时候,我问他:“儿子,你的心愿是什么?”儿子:“吃汉堡包。”我:“往大了说。”儿子:“买变形金刚。”我:“今天你爹说了算,想想,咱俩共同的心愿是什么?”儿子怯生生地瞅了媳妇一眼说:“换个妈?”

我在一个公司工作,3年的工资是6万块。老板说他有一张布加迪的10万块优惠券,问我工资要6万现金还是布加迪10万块优惠券,我毫不犹豫地要了10万块的布加迪优惠券,我是不是很机智?

昨天我在小区楼下等顾客下来拿外卖,我旁边的一男生估计是在等女朋友,他抽了口烟,忧伤地说:“有时候我真羡慕你们送外卖的,一个电话姑娘就下来了,不像我,每次都要等半小时,还不敢打电话催。”这一刻,我竟不知该如何安慰他。

我小时候有一次考砸了,因为怕挨揍,就打算假装上吊吓唬老爸,让他舍不得打我。那天我先回到家,搞了条绳子绑在吊扇上,我再站在凳子上,把脖子套到绳子系出来的圈圈里,计划等爸爸一回来我就踹凳子。我爸终于回来了,当时天热,他还没进客厅,就伸手进来先开吊扇。我瞬间脖子一紧,眼前一黑,像陀螺一样在空中转了起来……

昨天看到一对情侣在街头吵架,女的说:“够了!谁要你的关心!”这时,旁边推车卖杂货的小贩喇叭里传来这样的声音:“蟑螂要、蚂蚁要、臭虫要、老鼠要……”

很多朋友问我如何选购车辆,说实话,我并不太擅长,因为我的车基本上都是用一次就换了,并不能很深入地了解每辆车的实际性能。当然,这倒也不是因为我有钱任性,因为共享单车就是这样规定的!

我陪女友逛街买衣服,女友突然说:“咱俩在一起你是不是很幸福?我觉得你这几年成熟了许多。”我想想,的确是,两年前我还不会洗衣服煮饭洗碗拖地呢。



神句ONE

我有一个朋友听说抽烟影响生育,毅然决然地戒了要孩子的念头。

一个朋友刚24岁就说要去植发,我心里感叹,这才多大呀,就挣够植发的钱了。

才知道章鱼是喜欢吃龙虾的,这么便宜的食材吃这么贵的食材,不要脸!

小时候我们辞不达意,长大了我们言不由衷。
25 Nov 05:09

今早的对话

by maggiehuh
发信人: maggiehuh (darougougou), 信区: Joke
标 题: 今早的对话
发信站: 水木社区 (Thu Nov 23 15:30:45 2017), 站内

大清早被闺女吵醒,我恨恨的说:好梦都被你打断了
闺女:做的啥梦?
我:和你爹在日本玩。
闺女:有我没?
我:没
闺女:讨厌!都不带我


--
发自xsmth (iOS版)
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 106.38.140.*]
25 Nov 05:07

Reddit: 奇葩的911紧急求助电话

by Sunyata
发信人: Sunyata (水木诗妖龙静颜), 信区: Joke
标 题: Reddit: 奇葩的911紧急求助电话
发信站: 水木社区 (Thu Nov 23 12:29:09 2017), 站内

蛋奶 @ 2017.11.23 , 12:00 pm
Reddit热帖之“911接线员们,你们都接过哪些奇奇怪怪的紧急求助电话?”:

neinta:
“这里是911,请问有什么紧急情况?”
“我在路上看到了一头猪,超级无敌大。”
“先生,你的位置是哪里?”
“在红绿灯路口,我TM从来没见过那么大的猪。赶紧派人过来!”
(我们的小镇只有一个红绿灯路口,路口附近就有一个酒吧。当时是凌晨2:30,酒吧已经关门了。)
“那只猪有多大?”
“可能有只大众汽车那么大!”
“请问您喝了多少酒?”
“我特么根本没醉!这只巨猪大得快赶上一只小汽车了!我说你们是不是有毛病啊?”
警官赶过去的时候,发现了一只成年河马,是从当地野生动物园逃出来的。

dustydigital101:
很多老年人因为尿路感染而出现了幻觉。有一次,一名女性打电话过来请教如何给别人实施心肺复苏。急救队员赶到那里的时候,发现她正(轻轻地)给她家喵星人进行胸部按压。喵星人一脸懵逼,它看上去完全没有毛病。

Reddit: 奇葩的911紧急求助电话
CREDIT: 123RF

UncomfortableChuckle:
我妈曾当过20多年的911调度员。她跟我讲过一个奇怪的求助电话,一开始,电话那头并没有说话声音,只能听得到呼吸声。我妈一直在问问题,让他回答“是”或“否”,想要知道究竟发生了什么。最后那边的人终于吐出了几个字,他说想要伤害他的人还在现场,于是警员们都带上枪过去了。不过,他只说那个人还在那里,但没说那个人已经死了。

最后他们发现,这个人之所以讲不了话,是因为他的喉咙被割开了,而且还是他自己割的。这是为了让他自己看起来像是正当防卫,嗯,他杀了他的老婆。

HonestWill:
这是我听到过的事情,不是打给911的,但也差不多。紧急医疗服务站(EMS)接到了一个电话,有个男的说,有好多土豆钻进了他的直肠里面。而且不是红皮土豆,是棕色的大个的那种。

最好笑的是,这个男人是这样解释的:“我在浴缸里洗土豆,脚底打滑摔了一跤,那些土豆就跑进去了。” O_O exo me?

本文译自 reddit,由译者 蛋奶 基于创作共用协议(BY-NC)发布。
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 121.195.114.*]
24 Nov 03:58

CentOS 7 Nginx配置Let’s Encrypt SSL证书

by 标点符

去年购买的阿里云到期了,由于阿里云续费比新买贵很多,所以重现买了一台虚拟机,迁移过程中需要重新配置Let’s Encrypt证书,在执行过程中发现了一些问题,经过几个小时的摸索,终于搞定。

安装Let’s Encrypt证书一般的流程

yum install epel-release -y
yum install certbot -y

然后执行:

certbot certonly --webroot -w /home/www/www.biaodianfu.com -d www.biaodianfu.com -m biaodianfu@email.com --agree-tos

相关参数含义:

  • –webroot是运行模式
    • standalone模式:需要停止当前的 web server 服务,让出 80 端口,由客户端内置的 web server 启动与Let’ s Encrypt通信。
    • webroot模式:不需要停止当前 web server,但需要在域名根目录下创建一个临时目录,并要保证外网通过域名可以访问这个目录。
  • -w 指定网站所在目录
  • -d 指定网站域名
  • -m 指定联系邮箱,填写真实有效的,letsencrypt会在证书在过期以前发送预告的通知邮件
  • –agree-tos 表示接受相关协议

使用webroot模式,Certbot在验证服务器域名的时候,会生成一个随机文件,然后Certbot的服务器会通过HTTP访问你的这个文件,因此要确保你的 Nginx 配置好,以便可以访问到这个文件。

因为默认LNMP的虚拟主机里是禁止 . 开头的隐藏文件及目录的,所以访问http://www.biaodianfu.com/.well-known/acme-challenge/**** 这个链接的话返回403错误,所以必须在nginx配置的server节点下添加

location ~ /.well-known {
    allow all;
}

最终的配置文件如下:

server {
    listen       80;
    server_name  biaodainfu.com www.biaodianfu.com;
    index index.html index.htm index.php;
    charset utf-8;
 
    root   /home/www/www.biaodianfu.com;
    
    location / {
        try_files $uri $uri/ =404;
    }
    error_page 404 /404.html;
    error_page 500 502 503 504 /50x.html;
    location = /50x.html {
        root /usr/share/nginx/html;
    }
 
    location ~ \.php$ {
        try_files $uri =404;
        fastcgi_pass php-fpm;
        #fastcgi_pass unix:/var/run/php-fpm/php-fpm.sock;
        fastcgi_index index.php;
        fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
        include fastcgi_params;
    }
    
    location ~ .*.(gif|jpg|jpeg|png|bmp|swf|flv|mp3|wma)$
    {
        expires      30d;
    }
    
    location ~ .*.(js|css)$
    {
        expires      12h;
    }
	
    location ~ /.well-known {
        allow all;
    }
}

重新nginx后执行申请证书的操作,正常情况下可以看到如下的显示内容:

IMPORTANT NOTES:
 - Congratulations! Your certificate and chain have been saved at
   /etc/letsencrypt/live/www.biaodianfu.com/fullchain.pem. Your cert will
   expire on 2018-02-25. To obtain a new or tweaked version of this
   certificate in the future, simply run certbot again. To
   non-interactively renew *all* of your certificates, run "certbot
   renew"
 - If you lose your account credentials, you can recover through
   e-mails sent to biaodianfu@email.com.
 - Your account credentials have been saved in your Certbot
   configuration directory at /etc/letsencrypt. You should make a
   secure backup of this folder now. This configuration directory will
   also contain certificates and private keys obtained by Certbot so
   making regular backups of this folder is ideal.
 - If you like Certbot, please consider supporting our work by:

   Donating to ISRG / Let's Encrypt:   https://letsencrypt.org/donate
   Donating to EFF:                    https://eff.org/donate-le

完成后,再配置nginx服务器,将服务器配置成支持https的访问。

server {
  listen 80;
  server_name biaodianfu.com www.biaodianfu.com;
  return 301 https://www.biaodianfu.com$request_uri;
}

server {
    listen 443 ssl http2;
    server_name  biaodainfu.com www.biaodianfu.com;
    index index.html index.htm index.php;
    charset utf-8;

    root   /home/www/www.biaodianfu.com;

    ssl_certificate /etc/letsencrypt/live/www.biaodianfu.com/fullchain.pem;
    ssl_certificate_key /etc/letsencrypt/live/www.biaodianfu.com/privkey.pem;

    location / {
        try_files $uri $uri/ /index.php?$args;
    }

    error_page 404 /404.html;
    error_page 500 502 503 504 /50x.html;
    location = /50x.html {
        root /usr/share/nginx/html;
    }

    location ~ \.php$ {
        try_files $uri =404;
        fastcgi_pass php-fpm;
        #fastcgi_pass unix:/var/run/php-fpm/php-fpm.sock;
        fastcgi_index index.php;
        fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
        include fastcgi_params;
    }
    
    location ~ .*.(gif|jpg|jpeg|png|bmp|swf|flv|mp3|wma)$
    {
        expires      30d;
    }
    
    location ~ .*.(js|css)$
    {
        expires      12h;
    }
    
    location = /favicon.ico {
	log_not_found off;
	access_log off;
    }
    
    location ~ /.well-known {
        allow all;
    }
}

 

以上为一般的步骤与过程,现在在执行centos 7.2时并没有遇到什么问题,这次使用的是centos 7.4却发生了问题。

解决证书安装中的问题

问题一:ImportError: No module named ‘requests.packages.urllib3’

原因是系统自带的requests的版本太低,参照这个地址上的临时解决方案:

pip install requests urllib3 pyOpenSSL --force --upgrade

执行完引发第二个问题:ImportError: ‘pyOpenSSL’ module missing required functionality. Try upgrading to v0.14 or newer.

主要原因是RHEL/CentOS的官方源和epel源的pyOpenSSL版本太旧了,新版的certbot依赖于高版本的pyOpenSSL库,从而失败。

解决方案,卸载epel中的certbot和PyOpenSSL,使用pip进行安装certbot。

pip search certbot
yum remove certbot pyOpenSSL
pip install certbot

pip install certbot。 如果碰到了Python.h或者pyconfig.h找不到的错误,可以安装Python的devel包: yum install -y python-devel;再次运行命令,提示找不到opensslv.h头文件,再安装OpenSSL的devel包: yum install -y openssl-devel;再次运行pip install certbot命令,成功安装certbot。

完成后执行

certbot certificates
  进行验证。输出正常,说明pip安装了最新版的certbot,并且能正确运行。

证书的自动更新

由于这个证书的时效只有 90 天,我们需要设置自动更新的功能,帮我们自动更新证书的时效。首先先在命令行模拟证书更新:

certbot renew --dry-run

模拟更新成功的效果如下:

[root@iZuf64dhkm7u57qfwrrhw6Z ~]# certbot renew --dry-run
Saving debug log to /var/log/letsencrypt/letsencrypt.log

-------------------------------------------------------------------------------
Processing /etc/letsencrypt/renewal/www.biaodianfu.com.conf
-------------------------------------------------------------------------------
Cert not due for renewal, but simulating renewal for dry run
Plugins selected: Authenticator webroot, Installer None
Renewing an existing certificate
Performing the following challenges:
http-01 challenge for www.biaodianfu.com
Waiting for verification...
Cleaning up challenges

-------------------------------------------------------------------------------
new certificate deployed without reload, fullchain is
/etc/letsencrypt/live/www.biaodianfu.com/fullchain.pem
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
** DRY RUN: simulating 'certbot renew' close to cert expiry
**          (The test certificates below have not been saved.)

Congratulations, all renewals succeeded. The following certs have been renewed:
  /etc/letsencrypt/live/www.biaodianfu.com/fullchain.pem (success)
** DRY RUN: simulating 'certbot renew' close to cert expiry
**          (The test certificates above have not been saved.)
-------------------------------------------------------------------------------

IMPORTANT NOTES:
 - Your account credentials have been saved in your Certbot
   configuration directory at /etc/letsencrypt. You should make a
   secure backup of this folder now. This configuration directory will
   also contain certificates and private keys obtained by Certbot so
   making regular backups of this folder is ideal.
[root@iZuf64dhkm7u57qfwrrhw6Z ~]#

在无法确认你的 nginx 配置是否正确时,一定要运行模拟更新命令,确保certbot和服务器通讯正常。使用 crontab -e 的命令来启用自动任务,命令行:

crontab -e

添加配置:(每隔两个月凌晨2:30自动执行证书更新操作)后保存退出。

30 2 * */2 * /usr/bin/certbot renew --quiet && /bin/systemctl restart nginx

查看证书有效期的命令:

openssl x509 -noout -dates -in /etc/letsencrypt/live/www.biaodianfu.com/cert.pem

测试服务器 SSL 安全性

Qualys SSL Labs 提供了全面的 SSL 安全性测试,填写你的网站域名,给自己的 HTTPS 配置打个分。理想情况下得分是A+,如果你和我一样获得的是A-那么还有很多的改善空间。另外又扑云也有一个测试https的工具:https://www.upyun.com/https

相关改进:

1、生成Perfect Forward Security(PFS)键值

mkdir /etc/ssl/private/ -p
cd /etc/ssl/private/
openssl dhparam 2048 -out dhparam.pem

Perfect Forward Security(PFS),中文翻译成完美前向保密,2014年时候,由于心血漏洞(存在服务器私钥泄漏的可能),没有使用前向保密的站点,加密通信的数据可以通过私钥来解密,导致信息泄漏,这使得前向保密被重视起来。总的来说会更加安全,不能获得A+的评分主要原因也是因为它。(生成的时间有点长)

2、更新配置文件

# https://mozilla.github.io/server-side-tls/ssl-config-generator/
server {
    listen 80;
    server_name biaodianfu.com www.biaodianfu.com;
    return 301 https://www.biaodianfu.com$request_uri;
}
server {
    listen 443 ssl http2;
    server_name  biaodainfu.com www.biaodianfu.com;
    index index.html index.htm index.php;
    charset utf-8;
	
    add_header X-Frame-Options DENY;
    add_header X-Content-Type-Options nosniff;

    root   /home/www/www.biaodianfu.com;

    ssl_certificate /etc/letsencrypt/live/www.biaodianfu.com/fullchain.pem;
    ssl_certificate_key /etc/letsencrypt/live/www.biaodianfu.com/privkey.pem;
	
	ssl_session_timeout 1d;
    ssl_session_cache shared:SSL:50m;
    ssl_session_tickets off;

	# Diffie-Hellman parameter for DHE ciphersuites, recommended 2048 bits
    ssl_dhparam /etc/ssl/private/dhparam.pem;

	# intermediate configuration. tweak to your needs.
    ssl_protocols TLSv1 TLSv1.1 TLSv1.2;
    # 一般推荐使用的ssl_ciphers值: https://wiki.mozilla.org/Security/Server_Side_TLS
    ssl_ciphers 'ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA:ECDHE-RSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA:ECDHE-ECDSA-DES-CBC3-SHA:ECDHE-RSA-DES-CBC3-SHA:EDH-RSA-DES-CBC3-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:AES128-SHA256:AES256-SHA256:AES128-SHA:AES256-SHA:DES-CBC3-SHA:!DSS';
    ssl_prefer_server_ciphers on;
	
    # HSTS (ngx_http_headers_module is required) (15768000 seconds = 6 months)
    add_header Strict-Transport-Security max-age=15768000;
	
    location / {
        try_files $uri $uri/ /index.php?$args;
    }

    error_page 404 /404.html;
    error_page 500 502 503 504 /50x.html;
    location = /50x.html {
        root /usr/share/nginx/html;
    }

    location ~ \.php$ {
        try_files $uri =404;
        fastcgi_pass php-fpm;
        #fastcgi_pass unix:/var/run/php-fpm/php-fpm.sock;
        fastcgi_index index.php;
        fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
        include fastcgi_params;
    }
    
    location ~ .*.(gif|jpg|jpeg|png|bmp|swf|flv|mp3|wma)$
    {
        expires      30d;
    }
    
    location ~ .*.(js|css)$
    {
        expires      12h;
    }
    
    location = /favicon.ico {
	    log_not_found off;
	    access_log off;
    }
    
    location ~ /.well-known {
        allow all;
    }
}

其他参考:

22 Nov 06:10

大连地铁时报11.20

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.20
发信站: 水木社区 (Mon Nov 20 21:04:16 2017), 站内

兄弟,一首凉凉送给你

我在网上发了张自拍,很快就有一个妹子私聊我:“你真的这么帅吗?”我立刻给她发了一张没有美颜的照片。她依旧不信,让我拍身份证,我也拍了。她还是不信,让我拍一下反面,看看是不是真的,我又拍了。她仍然不信,让我用手拿着身份证对比着拍,我拍了。终于,她被我的英俊打动,跟我要电话,我激动得不得了,把号码发给了她,她就再没联系过我。最近几天,我接到了好多小额贷款要账的电话,想问问大家是什么情况?

我觉得当代居住环境有点太冷漠了。以前在农村,家里缺点啥,邻居之间上门借一借就都有了,有啥好吃的也不藏着掖着,会挨家给邻居们也分点。我记得我小时候在家挨打,还有一大帮邻居过来劝架呢,可现在不行了!昨天我爸揍了我有半个小时,邻居一点动静都没有,可以说是世态炎凉了。

记得有一次相亲,女方是我哥们的表妹。在相亲前哥们跟我说,他表妹特别看重第一印象,要是比较满意的话,就会跟对方聊一聊,不满意的话就会直接问对方有没有车房和存款,用这样的问题刁难对方,我谨记在心。相亲那天,他表妹看了我两三秒,开口问:“你有别墅吗?”我……

我刚买房那阵,要办各种手续证明文件、办贷款,然后交房接房、联系装修、跑建材市场,为了还房贷,我除了忙工作,还要接私活。我妈不想看到我这么累,于是出门旅游去了……

朋友被他家狗咬了,我们去探望。见到我们,他声泪俱下:“昨天晚上,感觉一个人喝酒没劲,就让它陪了两盅,没想到它酒品不行啊。”

我上小学一年级那年的教师节,班里有个脑回路很清奇的同学,叠了两个金元宝送给班主任。后来都五年级了,他还没当上少先队员。

在火车上听旁边一群年轻人聊天,说的是哪个地方的菜好吃,川湘鲁粤什么的。一个挺漂亮的女孩说:“我不爱吃湘菜。”旁边一个很久没插上话的男生立马接道:“我也是!还有生姜!”

冬天太冷了,我对老婆说:“夏天有空调,有冰激凌,我还是喜欢夏天,不喜欢冬天。”她说:“你喜欢夏天还不是因为街上的美女夏天穿得少?”我简直要疯了,女人所谓的第六感也太准了吧!



神句 ONE

冬天到了,我折起来后想想又放下的裤脚,就是我逝去的青春。

我们每个人都是梦想家,当梦走了,就只剩想家了。

如果武侠世界里最强者是扫地僧,那么机器人界里的最强者想必是扫地机器人了。

万死不辞:每天被气死一万次,但仍然不辞职。

22 Nov 06:09

大连地铁时报11.19

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.19
发信站: 水木社区 (Mon Nov 20 06:37:22 2017), 站内

和熊孩子斗智斗勇那点事儿

20年前,那时的我身上只有5块钱,你嫌弃我没钱,离开了我。感谢你离开我,我看清了这社会有多现实。于是我变得有了上进心,努力工作,改变了所有的缺点。如今我的身价,足足翻了66倍,我现在想问问你,你后悔了吗?

你想一夜暴富吗?你想身家过亿吗?你想衣食无忧吗?你想生活不愁吗?如果你想,那和我在一起,我们俩一起想。

花椒:温中散寒,除湿止痛,治积食停饮;辣椒:驱寒止痢,增强食欲,促进消化;肥牛:补中益气,滋养脾胃,化痰息风、止咳止涎;肥羊:暖中补虚,开胃健身,养胆明目……所以如果你说想要吃比火锅更健康更养生的东西,那我是没办法了。

吃过最苦的,是她的喜糖。喝过最酸的,是她的喜酒。拿过最烫的,是她的喜贴。遇见最高兴的,是她的儿子长得像我。

我最近总是手脚冰凉,网上说是肾虚所致。我坚持健身、喝枸杞泡茶一段时间还是不见效,于是一咬牙把取暖费交了,病就好了。

有些人耳根子特别软,你说什么东西好,他就买了;你说哪好玩,他就去了。你以为人家是没主见吗?错,人家有钱。

以后在聚会上,有人问你“要不要帮你介绍对象”时,你可以礼貌地微笑答道:“不必了,我已经有喜欢的人了,而且很多年来一直忘不掉他。”此时众人必然起哄,兴冲冲地追问你:“谁啊谁啊?”你再沉吟低眉,一字一句道:“可那个人啊,永远都是17岁了。”全场肯定顿时陷入死寂,从此再不会有人问你这个尴尬的问题……而没有人会知道你说的是柯南。

我去超市买东西,看到收银小妹长得挺漂亮,于是我就逗她:“老公、老爸、老妈,哪一个跟你没有血缘关系?”“老公。”收银小妹不假思索地答道。我赶紧笑咪咪地说:“哎,乖,老婆!”收银小妹羞怒嗔道:“呸!讨厌!”然后就我被她男朋友打得脸都花了……哈哈,骗你们的,其实腿也被打断了。



神句 ONE

在夏天说喜欢冬天的人,是不是又悄悄开始喜欢夏天了?

我的朋友很多,他们来自五湖四海。等我需要帮助的时候,他们又回去了。

俄罗斯方块教导我们:最受欢迎的总是那个又高又瘦的。

这世上没有谁离不开谁,就算是一条鱼离开水,也能烤着吃。

(部分笑话取自网络,如有侵权请联系删除)
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 123.151.77.*]

21 Nov 04:17

大连地铁时报11.13

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.13
发信站: 水木社区 (Tue Nov 14 06:34:42 2017), 站内

一白遮百丑,一傻毁所有

晚上我爸喝多了,被几个叔叔扶回家。把我爸安顿在沙发上后,叔叔们就要走,于是我出去送了一下。送完后,我刚回来把门关了,我爸就给了我个大耳光:“这么晚才回来!”

昨晚女朋友给我打电话,问我:“在做什么?”我不敢说我在打游戏,因为她不准我玩。没聊几分钟,游戏就要开团了,我赶紧说:“宝宝,我电话要没血了,过会儿充了电给你打。”

对面楼的一个独居姑娘这几天都穿得很少出现在客厅,曼妙的身材一览无遗,令人心动。今天在楼下碰到她,我终于按捺不住,上前问道:“你家已经供暖了?”

我家狗丢了,这两天我发疯似的到处找。早上在公园遇见一个大叔,我问他有没有见过我的狗,大叔问:“是不是只金毛,还穿着黄色马甲?”我激动不已,一把抓住大叔:“对!对!你是不是看见它了?”大叔:“没!这是你第三次问我了!”

哥们昨天去相亲,对方上来就问:“家里介绍说你挺好的,你可以具体说说自己哪里挺好的吗?”哥们愣了片刻,说:“我一个人挺好的。”

昨晚喝大了,朋友让他的下属开车送我回家。到家后,我去冰箱拿出了两个石榴让他吃,小兄弟还客气地很一直说不吃不吃。我让他带走,他也没带,放在柜子上就赶紧回去了。今早我起来往柜子上一瞧,嘿,两个洋葱!

上小学时老师经常拖堂,同学们决定联名举报,我第一个签字!然后举报信上只有我的名字,和三十几个指印!

小时候家里穷,看别人家孩子吃煮鸡蛋特别馋 ,回家哭着也要吃。老妈告诉我:“小孩吃鸡蛋容易噎着,妈给你炒鸡蛋丝吃。”就这样,我愉快地吃了好几年的炒土豆丝。


神句 ONE

言承旭选择前天承认复合很聪明,如果再早点,不就要帮林志玲清空购物车了吗?

到了电商购物季,上网逛了逛,看看缺什么,看了一圈发现缺的是钱。

我姓东方,父亲希望我一生不败,所以给我取名东方老赢。

大多数人戴表不是因为时间观念好,而是想知道还有多长时间可以拖延。

上厕所尽量选择干净的马桶,因为你不知道手机什么时候会掉进去。

“篮球场上哪句话最能击垮对手?”“你的鞋是假的!”

别再追捧野味了,好吃的动物已经被人类养殖了,没养殖的肯定不好吃啊。

感谢马云,让我们在每年的光棍节忘记脱单,专心感受贫穷。

(部分笑话取自网络,如有侵权请联系删除)
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 125.39.46.*]

16 Nov 11:39

大连地铁时报11.15

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.15
发信站: 水木社区 (Wed Nov 15 21:09:59 2017), 站内

小孩子任性,成年人认命

家有熊孩子两个,上午老婆出去让我看着,大的是十万个为什么,问这问那,小的比孙猴子还闹腾,看两个孩子比上一天班还累。快中午时,好不容易把两个小子弄睡着,老婆终于回来了。一进屋,老婆一脸关心地问我:“老公看孩子累吗?”我说:“太累了!”“那好吧,你去做饭,我来看会儿。”

相亲,女孩问:“你是做什么生意的?每月能赚多少钱?”我笑道:“我没做生意,在公司上班,月薪八千。”她:“八千工资对于单身狗来说省省还能生活,可结婚后你还要养我怎么办?”我愣了:“可我没想过要养你啊。”

昨天我在街上闲逛,看到老同学坐在劳斯莱斯里吃煎饼果子,我顿时就好羡慕,真希望有一天我也能吃得起煎饼果子。

只要舍得在健身上投入金钱,就一定会瘦下来。我有个朋友借钱买了几十万的私教课,现在每天被人追着还债,一个月瘦了50斤。

昨天我在给一家公司的女老总送快递,那家公司前台告诉我老总这段时间都不在深圳,要去北京待一段时间。我问:“要去北京拓展业务吗?”前台说:“不是,她买了很多好看的大衣,这边穿不了。”

别看有些人在人前有猫有狗,一副人生赢家的样子,其实他们背后还有车有房有存款,想出去旅游就出去旅游呢。

每天我和女朋友一起坐地铁下班。不知何时开始,地铁口总有个帅哥倚在跑车上对她眉目传情,女友先是无视,但帅哥和跑车每天准时出现,渐渐她脸上写满期待,对我越来越冷淡。直到那天,帅哥捧着红玫瑰问她:“离开他好吗?”“当然!”她很兴奋。他转向我:“她不爱你了,做我男朋友吧!”我接过了花束……

“双11”过了,在这个剁手的季节,我却并不想指责我那买买买的女友,而是感动至极。她总共买了24件东西,一共花了40365元,其中23件是给我买的!不说了,我现在去看看她那4万块的包长啥样。



笑出马甲线

@一切、随缘
小区楼下,一对住在这里的外地夫妻在吵架,说的都是方言,大家听不懂,但仍然有不少人围着关注。那男的不耐烦地吼:“你们看什么啊!听得懂吗就在那议论!”一个大哥怯怯地说:“我们就看个意境……”

@豆皮寿司
“这里有几种石头,你认得出哪个是雨花石,哪个是萤石,哪个是黑曜石,哪个是石榴石,哪个是月光石,哪个是玛瑙石吗?”“我怎么会知道!”“那你还真是六亲不认啊。”唐僧对孙悟空说。

@东土大唐三俗和尚
16 Nov 11:36

大连地铁时报11.07

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.07
发信站: 水木社区 (Wed Nov 8 06:24:10 2017), 站内

看不穿,是你清奇的脑洞
有一次,我带着3岁的女儿去银行存钱,晚上,女儿冲到刚进门的老婆身边,带着哭声说:“妈妈,怎么办啊!爸爸把很多钱都给那个阿姨了!”瞬间,老婆眼神透着杀气地看着我……

“或许现在就是一个透支的世界吧,透支身体去熬夜,透支钱去买东西,透支感情去爱,疯狂过后,却再也无法还原最初的样子。”“少废话,欠我的钱到底还不还?”

有钱人的脑回路果然与众不同。我和一个姐们吃东西,她是富二代,家里条件蛮好的,自己还买股票。她跟我说她去一个大公司当前台了,月薪几千,边说边微笑,开心之情溢于言表。我怀疑她家里是不是出啥事了,但是一看她依然开着豪车,似乎也没到山穷水尽的地步。我转念一想,她可能事业心起来了,女人就是要自强自立!我刚想夸她时,大姐自顾自地说:“我名牌包和衣服太多了,我想多一些人欣赏到它们。”

很久以前,我在家无聊地拿望远镜看外面,突然发现画面被分成一格一格的,像像素一样。当时我真的慌了,大脑一阵眩晕,不知所措地想自己该不会活在假的世界里吧……然后发现是因为纱窗没开。

为了方便和女友在一起,我们在快捷酒店办了张会员卡,用女友名字开的卡,留的是我的手机号。因为我工作忙,最近很少和女友去了,昨天我接到酒店的电话,说我们的卡升级成白金卡了,要核对信息。看来经济不景气,酒店也不好做啊,像我这样不常住酒店的都成了他们的重要客人了。

上小学的表弟和同学打架,老师让他回去叫家长。表弟硬气地说:“不用,我打得过他。”老师板着脸说:“必须叫家长来学校!和你打架的XXX已经回去叫他爸了。”表弟犹豫了一下,依然硬气地说:“两个我也打得过。”

在公交车上听见两个大妈在讨论生二胎的事。一个大妈说:“生二胎没啥用,孩子多了太累人。”另一个大妈说:“必须得生二胎!你看看武大郎,如果不是他妈妈生了武松,后来谁给他报仇啊?”

儿子3岁生日那天,趁他午睡,我买了条小狗回来,关笼子里放在床头柜上,还留了张纸条:宝贝生日快乐——爸爸。后来我出去买点东西,老婆来电话说儿子醒来后哭了,抓着笼子嚷:“爸爸,你怎么变成狗了!”



神句 ONE

我喜欢过的女生都有一个共同点,她们都跟我说:“你死心吧,我不会喜欢你的。”

谁能想到,我爸和我妈他俩的儿子,居然都是我!

世上最大的谎言就是旺铺转让,你有旺铺你舍得转让?

16 Nov 11:33

大连地铁时报11.05

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.05
发信站: 水木社区 (Mon Nov 6 06:09:17 2017), 站内

惊喜变惊吓,只要一句话

我家楼上住了一对小夫妻,经常为一些琐事大晚上吵吵闹闹,影响我休息。大前天晚上,楼上的妻子骂丈夫外出不锁门,导致家里丢了600块钱。前天晚上俩人又吵架,丈夫骂妻子车库门没关,车轱辘被人偷走两个。昨天晚上,他们又相互指责,说家里的电视被偷了是对方的责任。真的很烦,吵得我觉都睡不成了,以后再也不去他们家偷东西了。

陪老婆回娘家吃饭,我聊起了打篮球的话题,说自己怎样过人、投篮……丈母娘对老丈人说:“和你年轻时一样哈。”我说:“爸,您以前也爱打篮球?”老丈人:“我以前也和你一样,吃饭时话多。”

自从健身之后,我的饮食习惯就变了。以前吃美食想都不想就吃,现在要先看一看热量表,如果热量太高,我就含着眼泪吃。

以前我给一个美女当过备胎,她经常和我微信聊天,偶尔约我出来喝咖啡感慨一下人生,但从不跟我进一步发展。后来她说要结婚了,不能再和我联系,但她觉得我人不错,要把我介绍给她表妹。就这样,在她的撮合下,我和她表妹一见如故相识相知,最终成了她表妹的备胎。

本来在单位偷懒的时候,我还是有点愧疚的。但自从新的部门经理训诫我们说:“上班玩手机、看视频的时候想想你们的工资!”我偷起懒来就心安理得多了。

在柜台试口红,听见导购向路人女孩推荐眼霜:“什么?你还只用保湿眼霜?我跟你讲,女人过了25岁就要抗皱了,我23岁开始用这款眼精华,现在都27岁了,你看我眼角有皱纹吗?”女孩:“有啊。”

昨天我听说邻居家的老大娘和老大爷要闹离婚,我就纳闷了,都一把年纪了,怎么还闹离婚呢?后来才知道,前几天晚上停电,老大爷和老大娘找蜡烛,后来老大娘递给老大爷一根,老大爷点着了,结果响了。

我教我侄子做数学题,教了半天,他还是一窍不通。我没有放弃,而是找了几道同类型的数学题,启发侄子:“这几道题,都有一个相同点,你仔细看看,找出相同点就让你休息!”我侄子看了许久恍然大悟:“噢!这个相同点就是我都想不出来。”



神句 ONE

吾日三省吾身:不买岂不是更划算?

“为什么你总是喜欢看帅哥?”“我有男颜之瘾。”

趁好看的时候多照照镜子,毕竟这种错觉不是每天都有。

“‘双11’”时最该打折的是什么?”“自己的手。”

越长大越怀念以前和发小蹲在地上玩泥巴的日子,那时我蹲下去一点儿也不费劲。

16 Nov 03:08

大连地铁时报11.14

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.14
发信站: 水木社区 (Wed Nov 15 06:32:08 2017), 站内

那些年,我们见过的高级黑

我们寝室在宿舍开黑玩LOL。刚开局没多久,一个室友对象就打电话了,室友不接,继续玩,手机继续响,室友还是不接……来来回回5分钟。最后,室友被对面单杀两次后终于心态爆炸,双手狠狠向砸键盘,嘴里狂飙脏话,猛地一起身椅子差点被他带翻。我们没说话,都默默看着他,只见这货接起电话就是一句:“你在干嘛呀,我刚才刷牙去啦!”

为了活跃气氛,我每晚在饭桌上都会讲段子,但从来没人笑。我以为是因为我的段子不好笑,后来才知道,是因为我每天都一个人吃饭。

结婚那天,老公来迎亲,就在他把我抱出家门的时候,我妈哭了。我眼泪也止不住流了下来,回去抱住她说:“妈,我也舍不得你啊!”我妈哽咽着说:“终于把你嫁出去了……”

有一天,小猪佩奇哭着对妈妈说:“小朋友都说我长得像吹风机。”猪妈妈心疼地说:“乖,下次说话时离妈妈远一点,别把我头发吹乱了。”

闲来无事,刚刚看了世界财富排名,我是第6524571292名,相比昨天下降了3000万名,可能是昨晚花了两块五买啤酒的原因,以后要节约了!

我妈是个一辈子都没下过厨房的人,她做过的最接近“下厨”的一件事,就是往我的伤口上撒盐。

最近脱发有点严重,于是上个月托朋友帮我从德国带一个牌子的防脱洗发水。结果朋友太忙,昨天才发微信给我说他终于有空了,问我要几瓶,我说不用了。他说:“你在国内也能找到这个洗发水?”我说:“那倒不是,我就是已经用不着洗发水了。”

我6岁那年就离家出走了,在外面漂泊了10几年。半年前,我借了2万小额贷款,嘿,你还别说,不仅钱不用还了,他们还帮我把家人找到了。


神句 ONE

去电影院,一个妈妈带了三个小朋友,电影里的小兔子死了,兄妹三人抱头痛哭。

把快乐分享给了错的人,就成了显摆。

如果你真能看得出男朋友有没有潜力,直接做风投好了,还谈什么恋爱啊。

仔细想想,我上学的时候,学生之间有冲突,都是按照分数来划分责任。


笑出马甲线

@侯門
刚订婚那会儿,老婆把我拉进群,里面有老丈人、丈母娘、她和小姨子。当时丈母娘说:“欢迎,以后咱五个是一家人了。”第二天,他们四个又另外建了一个群。

@十个红指甲
把干净衣服放衣柜里了,脏衣服塞洗衣机里了,不太干净又不很脏的衣服也都统一随手扔在椅子上了,如此井井有条的生活习惯在我妈眼里怎么就成了没收拾呢?

@虹酒☆
15 Nov 03:58

Bash 脚本 set 命令教程

服务器的开发和管理离不开 Bash 脚本,掌握它需要学习大量的细节。

set命令是 Bash 脚本的重要环节,却常常被忽视,导致脚本的安全性和可维护性出问题。本文介绍它的基本用法,让你可以更安心地使用 Bash 脚本。

一、简介

我们知道,Bash 执行脚本的时候,会创建一个新的 Shell。


$ bash script.sh

上面代码中,script.sh是在一个新的 Shell 里面执行。这个 Shell 就是脚本的执行环境,Bash 默认给定了这个环境的各种参数。

set命令用来修改 Shell 环境的运行参数,也就是可以定制环境。一共有十几个参数可以定制,官方手册有完整清单,本文介绍其中最常用的四个。

顺便提一下,如果命令行下不带任何参数,直接运行set,会显示所有的环境变量和 Shell 函数。


$ set

二、set -u

执行脚本的时候,如果遇到不存在的变量,Bash 默认忽略它。


#!/usr/bin/env bash

echo $a
echo bar

上面代码中,$a是一个不存在的变量。执行结果如下。


$ bash script.sh

bar

可以看到,echo $a输出了一个空行,Bash 忽略了不存在的$a,然后继续执行echo bar。大多数情况下,这不是开发者想要的行为,遇到变量不存在,脚本应该报错,而不是一声不响地往下执行。

set -u就用来改变这种行为。脚本在头部加上它,遇到不存在的变量就会报错,并停止执行。


#!/usr/bin/env bash
set -u

echo $a
echo bar

运行结果如下。


$ bash script.sh
bash: script.sh:行4: a: 未绑定的变量

可以看到,脚本报错了,并且不再执行后面的语句。

-u还有另一种写法-o nounset,两者是等价的。


set -o nounset

三、set -x

默认情况下,脚本执行后,屏幕只显示运行结果,没有其他内容。如果多个命令连续执行,它们的运行结果就会连续输出。有时会分不清,某一段内容是什么命令产生的。

set -x用来在运行结果之前,先输出执行的那一行命令。


#!/usr/bin/env bash
set -x

echo bar

执行上面的脚本,结果如下。


$ bash script.sh
+ echo bar
bar

可以看到,执行echo bar之前,该命令会先打印出来,行首以+表示。这对于调试复杂的脚本是很有用的。

-x还有另一种写法-o xtrace


set -o xtrace

四、Bash 的错误处理

如果脚本里面有运行失败的命令(返回值非0),Bash 默认会继续执行后面的命令。


#!/usr/bin/env bash

foo
echo bar

上面脚本中,foo是一个不存在的命令,执行时会报错。但是,Bash 会忽略这个错误,继续往下执行。


$ bash script.sh
script.sh:行3: foo: 未找到命令
bar

可以看到,Bash 只是显示有错误,并没有终止执行。

这种行为很不利于脚本安全和除错。实际开发中,如果某个命令失败,往往需要脚本停止执行,防止错误累积。这时,一般采用下面的写法。


command || exit 1

上面的写法表示只要command有非零返回值,脚本就会停止执行。

如果停止执行之前需要完成多个操作,就要采用下面三种写法。


# 写法一
command || { echo "command failed"; exit 1; }

# 写法二
if ! command; then echo "command failed"; exit 1; fi

# 写法三
command
if [ "$?" -ne 0 ]; then echo "command failed"; exit 1; fi

另外,除了停止执行,还有一种情况。如果两个命令有继承关系,只有第一个命令成功了,才能继续执行第二个命令,那么就要采用下面的写法。


command1 && command2

五、 set -e

上面这些写法多少有些麻烦,容易疏忽。set -e从根本上解决了这个问题,它使得脚本只要发生错误,就终止执行。


#!/usr/bin/env bash
set -e

foo
echo bar

执行结果如下。


$ bash script.sh
script.sh:行4: foo: 未找到命令

可以看到,第4行执行失败以后,脚本就终止执行了。

set -e根据返回值来判断,一个命令是否运行失败。但是,某些命令的非零返回值可能不表示失败,或者开发者希望在命令失败的情况下,脚本继续执行下去。这时可以暂时关闭set -e,该命令执行结束后,再重新打开set -e


set +e
command1
command2
set -e

上面代码中,set +e表示关闭-e选项,set -e表示重新打开-e选项。

还有一种方法是使用command || true,使得该命令即使执行失败,脚本也不会终止执行。


#!/bin/bash
set -e

foo || true
echo bar

上面代码中,true使得这一行语句总是会执行成功,后面的echo bar会执行。

-e还有另一种写法-o errexit


set -o errexit

六、set -o pipefail

set -e有一个例外情况,就是不适用于管道命令。

所谓管道命令,就是多个子命令通过管道运算符(|)组合成为一个大的命令。Bash 会把最后一个子命令的返回值,作为整个命令的返回值。也就是说,只要最后一个子命令不失败,管道命令总是会执行成功,因此它后面命令依然会执行,set -e就失效了。

请看下面这个例子。


#!/usr/bin/env bash
set -e

foo | echo a
echo bar

执行结果如下。


$ bash script.sh
a
script.sh:行4: foo: 未找到命令
bar

上面代码中,foo是一个不存在的命令,但是foo | echo a这个管道命令会执行成功,导致后面的echo bar会继续执行。

set -o pipefail用来解决这种情况,只要一个子命令失败,整个管道命令就失败,脚本就会终止执行。


#!/usr/bin/env bash
set -eo pipefail

foo | echo a
echo bar

运行后,结果如下。


$ bash script.sh
a
script.sh:行4: foo: 未找到命令

可以看到,echo bar没有执行。

七、总结

set命令的上面这四个参数,一般都放在一起使用。


# 写法一
set -euxo pipefail

# 写法二
set -eux
set -o pipefail

这两种写法建议放在所有 Bash 脚本的头部。

另一种办法是在执行 Bash 脚本的时候,从命令行传入这些参数。


$ bash -euxo pipefail script.sh

八、参考链接

(完)

文档信息

14 Nov 11:54

大连地铁时报11.12

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.12
发信站: 水木社区 (Mon Nov 13 06:41:23 2017), 站内

我这条命,全靠买买买撑着

快到“双11”的时候,看到老婆的淘宝购物车里满满的东西,我灵机一动,把银行卡里的钱都转到了老妈的卡上。老婆如果要问起,我就说老妈急着用钱,过阵子再把钱转回来。转完钱后,我正暗自得意,老妈打电话给我,她在电话里激动地说:“哎呀,还是儿子孝顺,我正愁‘双11’你爸不给钱买东西呢!”

昨晚吃饭时,旁边坐了一对十分耿直的相亲男女,女孩:“那我直接问了哈,你现在每月能挣多少?”男孩:“我工资6000多,每月跟同事打麻将还能赢1000,很稳定。”

不要觉得在“双11”帮老婆清空购物车就好像过末日,你怎么不想想,要是不帮老婆清空购物车,可能就是你的祭日了。

下班后,我叫了一个快车,司机师傅打电话过来问我:“您在路边吗?有什么明显特征?”我说:“我手里拿了个iPhoneX,256G的!”

哥哥嫂子吵架了,我们都去劝。嫂子擤了下哭到不通气的鼻子,抹抹眼泪,看着窗外说:“要不是‘双11’还有几个快递在路上,我真想死了算了!”

专家指出:女人只要经常花钱,烦恼就会减少百分之80,情商和智商都会提高。我觉得这个专家很靠谱,但钱从哪来呢,专家没说。

如今的“双11”已经变味儿了,失去了传统节日的内涵。希望大家能不忘初心,不要因为买买东西就忘了自己还是单身这个事实。

牛仔裤可以说是最耐穿的裤子了,新的好看,穿旧了穿破了更好看。哪怕贵一点,但可以穿好多年,平均下来也很划算。我就因为这一点,才买了超多牛仔裤,以为能穿到老。可万万没想到,才第二年,我就变胖了不能穿了。牛仔裤,不曾输给沧桑,却败给了腰围。



神句 ONE

接下来这段时间,麻烦大家走路的时候注意脚下,别踩了我要吃的土。

“兄弟,我出车祸了,急需一笔钱。”“肇事司机是谁?什么车?”“我老婆,购物车。”

世界上最痛苦的三角恋:我爱食物,脂肪爱我。

社会调查数据显示越加班越单身, 越单身的人越会被安排加班。

“你是什么星座啊?”“金牛座,你是什么座的?”“我是肉做的。”

别看我表面上风风光光,其实背地里袜子已经掉到脚底了。

“你今天有点怪。”“哪里怪?”“怪好看的。”

每个成功男人的背后,都有一个女人,想要他的钱。

(部分笑话取自网络,如有侵权请联系删除)
--

※ 来源:·水木社区 http://m.newsmth.net·[FROM: 123.151.77.*]

07 Nov 08:11

大连地铁时报11.06

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.06
发信站: 水木社区 (Tue Nov 7 07:09:29 2017), 站内

没想到世间竟有这种操作!

有次我用微信转账转错了人,于是我开始刷屏,给他发个300多个表情,心想他看到几百条信息都是表情,应该就不会一条一条返回去看了。结果我如愿以偿,第二天,钱自动退回来了!

早期的Siri还没有那么智能。有一次晚上定闹钟,我说:“Siri,请叫我6点起床。”第二天,闹钟非但没响,还发现我手机把我的名字改成了“6点起床”。

女朋友跟我说,她爸喜欢铁观音,我找钢厂的朋友连夜给她爸浇了一个两米多高的,几十个人给她爸送家去了,我就想知道,我这么尽心尽力,凭啥她爸把我赶出来?

周末去餐厅吃饭,我正准备点餐,一个美女走过来腼腆地说:“那个,你看,今天情侣套餐优惠只要120元,单人套餐没有优惠要80元,可是我一个人,身上只带了60元,你也是一个人,可不可以……”我开心地说:“你是想我们一起拼个情侣套餐?”美女摇摇头:“可不可以借我20块钱?”

我突然有个大胆的想法:重新报名去读大学,4000元的学费和1000元的住宿费必然少于一年在外面的房租,然后我每天不去上课出去工作,最棒的是还有好多漂亮的女同学!这主意确实不错!

晚上跟媳妇玩石头剪刀布,输的要给赢的洗脚。我出剪刀她出布,然后她就说我输了。我问她为什么,她反问我:“5是不是比2大?”

一男同学喜欢坐在他前面的女生,想搭讪,可又不知怎么说,于是就用最原始的方法,借东西。“美女,你有橡皮吗?借我使使。”女生回头,把橡皮借给他。不一会儿,小刀、尺子等等也全借了。男生又想借,女生猛地回头:“你到底想干吗?”男生终于鼓起勇气,问她:“你有男朋友吗?”女生娇羞地回了一句:“干吗呀?”男生下意识地说:“借我使使。”

我们这的点心店招到学徒,第一件事一定是老板请客。老板把店里的各种点心一样不漏都拿出来,让学徒尽情吃,边吃边劝:“这个好,多吃点儿!那个贵,一定要尝尝!”要不了一顿饭,就能让学徒吃伤了,看见点心就泛酸反胃,再也不打偷吃的主意。这个故事告诉我们:细水长流才能吃得更多。



神句 ONE

有志者事竟成。创业失败100多次后,我终于成功地学会了安慰自己。

我们好多人就是像是路牌,站在路边给迷茫的人指路,自己却去不了想去的地方。

谈恋爱应该处处让着男朋友:让他做饭、让他洗碗、让他洗衣、让他赚钱。

能让我“废寝”的事还有几件,但能让我“忘食”的事几乎没有了。

04 Nov 06:21

大连地铁时报11.02

by nzhth
发信人: nzhth (n站同号), 信区: Joke
标 题: 大连地铁时报11.02
发信站: 水木社区 (Thu Nov 2 20:39:51 2017), 站内

清晨喝鸡汤,上班心不慌


有些年轻人可以P自拍照,但是不能太过分,不然别人看到真人之后不仅仅觉得你丑,还会觉得你虚伪。

不是我跟你们吹牛,我5年前考的驾照,上个礼拜才买车,这期间我一次车都没开过。别人都以为我忘记了交通规则,忘记了如何开车,然而我用事实证明了,开车也需要一种天分。闲话少说,出售一款2017年的英朗,刚刚开了20公里,驾照吊销了。

分期买东西其实很可怕。比如买一个喜欢的东西,每个月还那么一点钱,让我有种根本不用花钱就能得到它的错觉。

其实真正爱钱、把钱排在第一位的人并不多。有些天天喊穷的人,一下班便要放飞自我,说到工作就愁眉苦脸,他们喜欢懒,要远远胜过喜欢钱。

接触的60后、70后多了,会发现他们身上普遍有一种80后、90后没有的淡定。那种气定神闲、宠辱不惊,非大风大浪之后不能有,在人群中,60后和70后颇有定海神针的作用。他们也乐于和年轻人分享各种人生、职场的经验,丝毫不担心后生们会复制他们的成功。不过这一切的奥秘,用3个字就可以总结:买房早。

每天吃燕窝的女孩皮肤好,不是因为燕窝有多神,而是因为有钱。不用搬砖,心情好气色自然好,就连内分泌都正常,皮肤能不好吗?

你整天抱怨,说房贷压得你喘不过气来。但人生在世,凡事都得往好处想,你有房贷可还,起码证明你有房,而那些连房贷都没得还的人,很可能是全款买的。

有时想想还是以前好。来电话时,“啪”的一声翻盖打开,充满仪式感,谈了多少亿的项目大声讲出来,路人侧耳倾听。现在不行了,无论自己的世界是天塌了还是圆满了,都只是默默对着手机打字,外观上一点儿看不出来。


?

笑出马甲线


@easy

我一个朋友平时就喜欢做小程序,如今做了一年多,终于挣钱了,应该能有上千万……因为他家在北京丰台的房子要拆迁了。

@P

地铁上,我给一个白发苍苍的人让座。他一转头,露出了一张30多岁的脸,显然这是一个养生有方的程序员。

@糯米坨坨

昨晚散步,我牵着妈妈的手在大街上走,我摸着她手上厚厚的茧,心里一阵阵心酸。我问妈妈:“妈,你手上的茧是哪来的?”我妈淡淡地说了一句:“打麻将磨的。”



段子手荟萃


女人真的很奇怪,她们总嚷嚷着自己体内有湿气,吃红豆薏米,却能在浴室里呆上两个小时,而且还会涂上各种保湿霜。百度贴吧